/**
 * This is a template for new plugin wrappers
 *
 * TODO:
 * - Add/Change information below
 * - Document usage (importing, executing main functionality)
 * - Remove any imports that you are not using
 * - Remove all the comments included in this template, EXCEPT the @Plugin wrapper docs and any other docs you added
 * - Remove this note
 *
 */
import { Injectable } from '@angular/core';
import { Plugin, Cordova, AwesomeCordovaNativePlugin } from '@awesome-cordova-plugins/core';

/**
 * @name Shuto ZebraPrinter
 * @description
 * This plugin does something
 *
 * @usage
 * ```typescript
 * import { ShutoZip } from '@shuto-cordova-plugins/zip';
 *
 *
 * constructor(private shutoZip: ShutoZip) { }
 *
 * ...
 *
 *
 * this.shutoZip.functionName('Hello', 123)
 *   .then((res: any) => console.log(res))
 *   .catch((error: any) => console.error(error));
 *
 * ```
 */
export interface Printer {
  name: string;
  address: string;
}
export interface PrinterStatus {
  connected: boolean;
  isReadyToPrint?: boolean;
  isPaused?: boolean;
  isReceiveBufferFull?: boolean;
  isRibbonOut?: boolean;
  isPaperOut?: boolean;
  isHeadTooHot?: boolean;
  isHeadOpen?: boolean;
  isHeadCold?: boolean;
  isPartialFormatInProgress?: boolean;
}
@Plugin({
  pluginName: 'ZebraPrinter',
  plugin: 'ca-cleversolutions-zebraprinter',
  pluginRef: 'ZebraPrinter',
  repo: 'https://m.shuto.cn:8681/public/cordova-zebra-printer.git',
  platforms: ['Android', 'iOS'],
})
@Injectable()
export class ZebraPrinter extends AwesomeCordovaNativePlugin {
  @Cordova()
  async discover(): Promise<Array<Printer>> {
    return [];
  }
  @Cordova()
  async print(cpcl: string): Promise<any> {
    return;
  }
  @Cordova()
  async isConnected(): Promise<boolean> {
    return false;
  }
  @Cordova()
  async printerStatus(): Promise<PrinterStatus> {
    return null;
  }
  @Cordova()
  async connect(adress: string): Promise<any> {
    return;
  }
  @Cordova()
  async disconnect(): Promise<any> {
    return;
  }
}
